#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

int P,N;
int grafo[450][450];
int numadj[450];

int cap[450][450];

int read(){
    
    scanf("%d %d",&P,&N);
    int i,j;
    memset(numadj,0,sizeof(numadj));
    memset(cap,0,sizeof(cap));
    
    for(i=1;i<=P;i++){
        grafo[0][numadj[0]++] = i;
        grafo[i][numadj[i]++] = 0;
        cap[0][i] = 1;
        
        int t;
        scanf("%d",&t);
        for(j=0;j<t;j++){
            int k;
            scanf("%d",&k);
            grafo[i][ numadj[i]++ ] = P+k;
            grafo[P+k][numadj[ P+k ]++ ] = i;
            cap[i][P+k] = 1;
        }
    }
    
    for(i=1;i<=N;i++){
        grafo[P+i][numadj[P+i]++ ] = P+N+1;
        grafo[P+N+1][numadj[P+N+1]++ ] = P+i;
        cap[P+i][P+N+1] = 1;
    }
    return 1;
}

int pai[500];

int aumenta(int no){
    if( no == 0 ) return 1;
    cap[ pai[no] ][no] -= 1;
    cap[no][pai[no]] += 1;
    aumenta( pai[no] );
    return 1;
}

int bfs(){
    char mark[500];
    queue < int > fila;
    fila.push(0);
    memset(mark,0,sizeof(mark));
    mark[0] = 1;
    memset(pai,-1,sizeof(pai));
    
    while(!fila.empty()){
        int no = fila.front();
        fila.pop();
            
        int i;
        for(i=0;i<numadj[no];i++){
            if( !mark[ grafo[no][i] ] && cap[no][ grafo[no][i] ] > 0 ){
                pai[grafo[no][i]] = no;
                if( grafo[no][i] == P+N+1 )   return aumenta(P+N+1);
                mark[grafo[no][i]] = 1;
                fila.push(grafo[no][i]);
            }
        }
    }
    return 0;
}

void process(){
    
    if( N < P ){
         printf("NO\n");   
         return ;
    }
    
    int flow =0;
    int k;
    
    for(k=1;k<=P;k++){
        if( numadj[k] == 0 ){
            printf("NO\n");   
          return ;
        }
    }
    
    while(k=bfs()) flow+=k;
    
    if( flow == P ){
        printf("YES\n");
    }
    else printf("NO\n");
}

int main(){
    
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    int casos;
    scanf("%d",&casos);
    while(casos--){
        read();
        process();
    }
    return 0;
}
