#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sstream>

using namespace std;

struct Point{
    double x,y;
    
    Point(){
        
    }
    
    Point(double x,double y){
        this->x = x;
        this->y = y;
    }

    Point operator -( Point t ){
        return Point(x-t.x,y-t.y);
    }
    double operator *( Point t){
        return x*t.y-y*t.x;
    }
};

char linha[1<<20];

Point pontos[1000];
int saida[1000];
int N,T;

char rr[1000][100];

int used[1000];

int read(){
    if( fgets(linha,1<<20,stdin) == NULL ) return 0;

    istringstream in(linha);
    
    N = 0;
    while( in >> rr[N] ){
        sscanf(rr[N],"(%lf,%lf)",&(pontos[N].x),&(pontos[N].y));
        N++;
    }
    
    return 1;
}

#define EPS 1E-9

int comp(double a,double b){
    if( fabs(a-b) <= EPS ) return 0;
    if( a < b ) return -1;
    return 1;
}

void convex(){
    
    int start=0,p,n,i;
    T = 0;
    
    for(i=1;i<N;i++){
        if( pontos[i].x < pontos[start].x ) start = i;
        else if( pontos[i].x == pontos[start].x && pontos[i].y > pontos[start].y ) start = i;
    }
    
    memset(used,0,sizeof(used));
    
    p = start;
    saida[T++] = start;
    
    do{
        n = -1;
        double dist = 0;
        
        for(i=0;i<N;i++){
            if( i == p || used[i] ) continue;
            if( n == -1 ) n = i;
            
            double cross = (pontos[i]-pontos[p])*(pontos[n]-pontos[p]);
            
            if( comp(cross,0) < 0 ){
                n = i;
                dist = sqrt( (pontos[n].x - pontos[p].x)*(pontos[n].x - pontos[p].x) + 
                                (pontos[n].y - pontos[p].y)*(pontos[n].y - pontos[p].y) );
            }
            else if( comp(cross,0) == 0 ){
                double d = sqrt( (pontos[i].x - pontos[p].x)*(pontos[i].x - pontos[p].x) + 
                                (pontos[i].y - pontos[p].y)*(pontos[i].y - pontos[p].y) );
                if( comp(d,dist) > 0 ){
                    n = i;
                    dist = d;
                }
            }
        }
        p = n;
        saida[T++] = p;
        used[p] = 1;
        
    }while(p!=start);
    
    
}

void process(){
    convex();
    int i;
    for(i=0;i<T;i++){
        if( i ) printf(" ");
        printf("%s",rr[saida[i]]);
    }
    printf("\n");
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    while(read())process();
    return 0;
}
