#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sstream>
#include <algorithm>
#include <map>
#include <vector>
#include <ctype.h>

using namespace std;

map < char , int > mapa;

vector < int > adj[1000];
int V;
char temp;

int read(){
    int i;
    
    for(i=0;i<V;i++) adj[i].clear();
    int id = 1;
    mapa.clear();
    
    while(1){
        if(scanf("%c",&temp) != 1 ) return 0;
        if( temp == '{' ) break;
    }
    
    while(1){
        if(scanf("%c",&temp) != 1 ) return 0;
        if( temp == '}' ) break;
        else if( isalpha(temp) ){
            if( !mapa[temp] ){
                mapa[temp] = id++;
            }
        } 
    }
    
    V = id;
    while(1){
        if(scanf("%c",&temp) != 1 ) return 0;
        if( temp == '{' ) break;
    }
    
    char a=-1,b=-1;
    
    while(1){
        if(scanf("%c",&temp) != 1 ) return 0;
        if( temp == '}' ) break;
        else if( isalpha(temp) ){
            if( a == -1 ) a = temp;
            else b = temp;
            
            if( a != -1 && b != -1 ){
                if( mapa[a] && mapa[b] ){
                    adj[mapa[a]].push_back( mapa[b]);
                    adj[mapa[b]].push_back( mapa[a]);
                }
                a = b = -1;
            }
        }
    }
    
    return 1;
}

int start,t;
char mark[1000];

int dfs(int no){
    
    mark[no] = 1;
    t++;
    int i;
    for(i=0;i<adj[no].size();i++){
        if( !mark[ adj[no][i] ] ){
            dfs(adj[no][i]);
        }
    }
    return 0;
}

void process(){
    int i;
    memset(mark,0,sizeof(mark));
    
    t = 0;
    for(i=1;i<V;i++){
        if( adj[i].size() ){
            dfs(i);
            break;
        }
    }
    
    if( !t || t != V - 1 ){
        printf("No ");
    }
    else{
        int cont = 0;
        for(i=1;i<V;i++){
            if( adj[i].size()%2 ){
                cont++;
            }
        }
        if( cont == 2 ){
            printf("Yes ");
        }
        else{
            printf("No ");
        }
    }
    
    
    memset(mark,0,sizeof(mark));
    t = 0;
    
    for(i=1;i<V;i++){
        if( adj[i].size() ){
            dfs(i);
            break;
        }
    }
    
    if( !t ){
        printf("Yes\n");
        return ;
    }
    
    if( t != V - 1 ){
        printf("No\n");
    }
    else{
        for(i=1;i<V;i++){
            if( adj[i].size()%2 ){
                printf("No\n");
                return ;
            }
        }
        printf("Yes\n");
    }
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);

    while(read()){
        process();
    }
    return 0;
}
